from __future__ import with_statement
from pasteob import webob_middleware
from mext.context import Setting, State

__all__ = ['creq', 'creq_mw']

_creq = Setting()

class CurrentRequest(object):
    get = _creq.get
    def __getattr__(self, name):
        req = _creq.get()
        if req is None:
            raise RuntimeError("No current request")
        return getattr(req, name)

    def __setattr__(self, name, value):
        raise AttributeError("creq attrs are not settable")


creq = CurrentRequest()

@webob_middleware
def creq_mw(req, app, stateful_iter=False):
    with State.child():
        _creq.set(req)
        r = req.get_response(app)
        if stateful_iter and not isinstance(r._app_iter, (list, tuple)):
            r.body # flatter app_iter
        return r
